




import re
import sys
import matplotlib.pyplot as plt
import numpy as np
import networkx as nx
import pyexcel
import gurobipy as gp
from gurobipy import GRB

G = nx.DiGraph()


iterate = np.array([0, 3.5, 1, 0.75, 0.75, 2, 1, 0.75, 2.9, 1.2, 0.6, 0.4, 2, 2, 1.7, 5.4, 4.4]) #distance between ports
iterate2 = np.flip(iterate)                                                                        #flip the distanc vector above as this is a pendulum service
iterate3 = np.append(iterate,iterate2)                                                              #adding the flipped distance vector to the first distance vector
fasit = np.add.accumulate(iterate3)                                                                 # Accumulating the distances to find find distances to all stops from start node
fasit = fasit[:-1]                                                                                  #removing last element as it is counted twice



distanceMatrSimple = np.zeros((len(fasit),len(fasit)))          #  creating distance matrix with distance from all ports to all ports
for i in range(len(fasit)):
    for j in range(len(fasit)):
        tall = np.abs(fasit[i]-fasit[j])
        distanceMatrSimple[i][j] = tall
    #distanceMatrix[i] = holder[i][j]


pyexcel.save_as(array=distanceMatrSimple, dest_file_name="B21DistanceMatrix.xlsx") #Saving distance matrix to excel






N = np.arange(len(distanceMatrSimple))  # The set N with the nodes/stops

Start = N[0] #first node in set N
Slutt = N[-1] # Last node in set N




Bat_alt = [0,1,2,3,4,5]                                      # Set with alternative for number of battery modules taken onboard in each stop. Expandedn to 4 for Baronessen and five for Baronen
#range_bat = [0,10,20,30] #Tidevind 
#range_bat = [0, 11.8,23.6,35.4, 47.2] #Baronessen           # Range for vessels with 500kWh/module available, with 0-3,4 and 5 battery modules for Tidevind, Baronessen and Baronen, respectively.
#range_bat = [0,8.2,16.4,24.6,32.8,41]  #Baronen

#range_bat = [0,8,16,24] #Tidevind80%DOD
#range_bat = [0, 9.42, 18.84, 28.26, 37.68] #Baronessen80%DOD           Range for vessels with 400kWh/module available, with 0-3,4 and 5 battery modules for Tidevind, Baronessen and Baronen, respectively.
range_bat = [0, 6.53, 13.06, 19.59, 26.12, 32.65] #Baronen80%DOD


cost_bat = np.array([0, 0.25, 0.55, 0.85, 1.15, 1.45 ])   # Cost of takeing on different numbers of battery modules, from 0-5 modules



A = [(i,j) for i in N for j in N if i<j] # All possible arcs between i and j, excluding when i == j
S = {(i,j): distanceMatrSimple[i,j] for i,j in A if j!=0 and distanceMatrSimple[i,j] <=max(range_bat) } #Set with all arcs and distances between arcs. As the route goes one way, duplicates are removed. Only generates arcs shortes than the range of the alternative taking on most battery module

cost = [0]*len(N)#Cost of establishing charging in each port
cost[0] = 1.5
cost[1] = 1.5/2
cost[2] = 1.7/2
cost[3] = 1.7/2
cost[4] = 1.9/2
cost[5] = 1.9/2
cost[6] = 1.7/2
cost[7]  = 1.7/2                #Half the cost is assigned to the establishing of the swapping station one way. The other half is added going back. 
cost[8] = 1.9/2                 #As the stops representing the same ports are constrained to be equal to each other, the full cost will be accounted for in the objective func
cost[9] = 1.9/2
cost[10] = 1.5/2
cost[11] = 1.9/2            
cost[12] = 1.9/2
cost[13] = 1.9/2
cost[14] = 1.5/2
cost[15] = 1.7/2
cost[16] = 1.5

for i in range(int(len(cost)/2)):       #Assigning cost to the corresponding port going back
    cost[16+i] = cost[16-i]




arcsData = []
for i,j in S:
    arcsData.append((i,j,S[i,j])) # Rewriting S to use it with gurobi

G.add_edges_from(S)

#GUROBI
#The optimization model 

m = gp.Model()
m.update()
x = m.addVars(S, vtype = GRB.BINARY, name = 'x') # Se thesis for description of variables
y = m.addVars(N,Bat_alt, vtype = GRB.BINARY, name = 'y')
u = m.addVars(N, vtype = GRB.BINARY, name = 'u')
z = m.addVars(S, vtype = GRB.BINARY, name = 'z')


m.modelSense = GRB.MINIMIZE #minimizing the Objective function

m.setObjective(gp.quicksum((cost[i]*u[i] for i in N )) + gp.quicksum(y[a,b]*cost_bat[b] for a in N for b in Bat_alt)  ) 

start_const = []
for a in arcsData:                      # prep for constraint 6.6
    if a[0] == Start:
        start_const.append(a)

end_const = []
for a in arcsData:                          #prep for constraint 6.7
    if a[1] == Slutt:
        end_const.append(a)


m.addConstrs(z[i,j]-x[i,j] == 0 for i,j in S)
m.addConstrs(z[i,j] >= x[i,j]+u[i]-1 for i,j in S)
m.addConstrs(z[i,j]<= x[i,j] for i,j in S)               #Linearization contraints. 6.2 -6.4
m.addConstrs(z[i,j]<= u[i] for i,j in S)



m.addLConstr(gp.quicksum(x[a[0],a[1]] for a in start_const) == 1) # Constraint 6.6: Only one of the arcs going from the start node can be included in the solution
m.addLConstr(gp.quicksum(x[a[0],a[1]] for a in end_const) == 1) # Constraint 6.7: Only one of the arcs going to the end node can be included in the solution
m.addConstrs((gp.quicksum(y[i,b]*range_bat[b] for b in Bat_alt) >= x[i,j]*S[i,j]  for i,j in S )) #Fiks opp det her OG FORTSETT DET GODE ARB>EIDET
m.addConstrs(gp.quicksum(y[a,b] for b in Bat_alt)<=1 for a in N) 
m.addConstrs((u[i] - u[Slutt-i])  == 0 for i in N) #constraint for pendulum service service. constraint 6.13
m.addConstr(u[Start] == u[Slutt]) # The first and last node represent the same port and thus needs to have the same value for u

#Constraint 6.8: The sum in and out of a node has to be equal for all nodes except the start and the end node
#  In combination with the above constraints this leads to a node having one arc in and one arc out in use(a part of the solution) or no arcs at all in use
for v in G.nodes:
    if v not in [Start,Slutt]:

        expr1 = gp.quicksum(x[i,v] for i in G.predecessors(v))

        expr2 = gp.quicksum(x[v,j] for j in G.successors(v))

        m.addLConstr(expr1 - expr2 == 0)

m.optimize()

print(m.display())

m.write('test.mps')
if m.Status != GRB.OPTIMAL:
    print('Optimization ended with status %d' % m.Status)
    sys.exit(0)

for v in m.getVars():
    print('%s %g' % (v.VarName, v.X))


print('The Objective value: %g' % m.ObjVal)


#PRINTING SOLUTION
#Printing the nodes in the solutions in vector form
result_nodes = []
for v in m.getVars():

    if v.X == 1 and 'u' in v.VarName:
        result_nodes.append(v.varName)


mellomhold = []
for a in result_nodes:
    b = re.findall(r'\d+',a)
    mellomhold.extend(b)

results_vec = []
for b in mellomhold:
    if b.isdigit():
        results_vec.append(int(b))

results_vec = list(sorted(set(results_vec)))
print(results_vec)


battery_data = []
for v in m.getVars():
    if v.X > 0.5 and 'y' in v.VarName:
        battery_data.append(v.VarName)

mellomhold_bat = []
for a in battery_data:
    b = re.findall(r'\d+',a)
    mellomhold_bat.extend(b)

results_vec_y = []
for b in mellomhold_bat:
    if b.isdigit():
        results_vec_y.append(int(b))

battery_station = results_vec_y[0::2]
batter_choice = results_vec_y[1::2]

for i in range(len(battery_station)):
    print('Port %s will supply vessel with %s batteries' %(battery_station[i],batter_choice[i]) )
        #battery_data.append(int(v.VarName[4]))

print('The nodes in the solution:',results_vec)


pos = nx.kamada_kawai_layout(G) # Visulizing all possible feasible connections between the nodes


options = {'node_color': 'cyan','node_size': 200,'width': 0.5}

#Drawing network with all possible feasible connections between nodes
plt.figure()
nx.draw(G,pos, with_labels=True, **options)
#dist = {(e[0],e[1]):str(G.edges[e[0],e[1]]['weight']) for e in list(G.edges())}
#nx.draw_networkx_edge_labels(G,pos,edge_labels=dist,font_color='red')

#Drawing the network with nodes and arcs in the solution
plt.figure()
nx.draw(G,pos, with_labels=True, **options)
shortPath = [(results_vec[i],results_vec[i-1]) for i in range(len(results_vec)-1,0,-1)]
nx.draw_networkx_edges(G,pos,edgelist=shortPath,width=5,edge_color='red')

print(m.Runtime) # printing the runtime of the script

plt.show()

