
import re
import sys
import copy
import matplotlib.pyplot as plt
import numpy as np
import networkx as nx
import pyexcel
import gurobipy as gp
from gurobipy import GRB

G = nx.DiGraph()



iterate = np.array([0, 3.5, 7.4, 2.2, 6.6, 2, 1.4])
iterate2 = np.flip(iterate)
iterate3 = np.append(iterate,iterate2)
fasit = np.add.accumulate(iterate3)
fasit = fasit[:-1]



distanceMatrSimple = np.zeros((len(fasit),len(fasit)))
for i in range(len(fasit)):
    for j in range(len(fasit)):
        tall = np.abs(fasit[i]-fasit[j])
        distanceMatrSimple[i][j] = tall



pyexcel.save_as(array=distanceMatrSimple, dest_file_name="B22DistanceMatrix.xlsx")




N = np.arange(len(distanceMatrSimple))

Start = N[0]
Slutt = N[-1]



Bat_alt = [0,1,2,3]
#range_bat = [0,10,20,30] #Tidevind
#range_bat = [0, 11.8,23.6,35.4, 47.2] #Baronessen
#range_bat = [0,8.2,16.4,24.6,32.8,41] #[9.75, 19.5]#, 29.25, 39] #Baronen

range_bat = [0,8,16,24] #Tidevind80%DOD
#range_bat = [0, 9.42, 18.84, 28.26, 37.68] #Baronessen80%DOD
#range_bat = [0, 6.53, 13.06, 19.59, 26.12, 32.65] #Baronen80%DOD


cost_bat = np.array([0, 0.25, 0.55, 0.85, 1.15, 1.45 ])



A = [(i,j) for i in N for j in N if i<j] 
S = {(i,j): distanceMatrSimple[i,j] for i,j in A if j!=0 and distanceMatrSimple[i,j] <=max(range_bat) } 



cost = [0]*len(N)#Cost of establishing charging in each port
cost[0] = 1.5
cost[1] = 1.5/2
cost[2] = 1.9/2
cost[3] = 1.7/2
cost[4] = 1.9/2
cost[5] = 1.9/2
cost[6] = 1.5


for i in range(int(len(cost)/2)):
    cost[6+i] = cost[6-i]



arcsData = []
for i,j in S:
    arcsData.append((i,j,S[i,j])) 


G.add_edges_from(S)

#GUROBI
#The optimization model 

m = gp.Model()
m.update()
x = m.addVars(S, vtype = GRB.BINARY, name = 'x') 
y = m.addVars(N,Bat_alt, vtype = GRB.BINARY, name = 'y')
u = m.addVars(N, vtype = GRB.BINARY, name = 'u')
z = m.addVars(S, vtype = GRB.BINARY, name = 'z')


m.modelSense = GRB.MINIMIZE #minimizing the Objective function

m.setObjective(gp.quicksum((cost[i]*u[i] for i in N )) + gp.quicksum(y[a,b]*cost_bat[b] for a in N for b in Bat_alt)  ) 


start_const = []
for a in arcsData:
    if a[0] == Start:
        start_const.append(a)

end_const = []
for a in arcsData:
    if a[1] == Slutt:
        end_const.append(a)


m.addConstrs(z[i,j]-x[i,j] == 0 for i,j in S)
m.addConstrs(z[i,j] >= x[i,j]+u[i]-1 for i,j in S)
m.addConstrs(z[i,j]<= x[i,j] for i,j in S)
m.addConstrs(z[i,j]<= u[i] for i,j in S)



m.addLConstr(gp.quicksum(x[a[0],a[1]] for a in start_const) == 1) 
m.addLConstr(gp.quicksum(x[a[0],a[1]] for a in end_const) == 1) 
m.addConstrs((gp.quicksum(y[i,b]*range_bat[b] for b in Bat_alt) >= x[i,j]*S[i,j]  for i,j in S )) 
m.addConstrs(gp.quicksum(y[a,b] for b in Bat_alt)<=1 for a in N) 
m.addConstrs((u[i] - u[Slutt-i])  == 0 for i in N) 
m.addConstr(u[Start] == u[Slutt])


for v in G.nodes:
    if v not in [Start,Slutt]:

        expr1 = gp.quicksum(x[i,v] for i in G.predecessors(v))

        expr2 = gp.quicksum(x[v,j] for j in G.successors(v))

        m.addLConstr(expr1 - expr2 == 0)


m.optimize()

print(m.display())

m.write('test.mps')
if m.Status != GRB.OPTIMAL:
    print('Optimization ended with status %d' % m.Status)
    sys.exit(0)

for v in m.getVars():
    print('%s %g' % (v.VarName, v.X))


print('The Objective value: %g' % m.ObjVal)


result_nodes = []
for v in m.getVars():

    if v.X == 1 and 'u' in v.VarName:
        result_nodes.append(v.varName)


mellomhold = []
for a in result_nodes:
    b = re.findall(r'\d+',a)
    mellomhold.extend(b)

results_vec = []
for b in mellomhold:
    if b.isdigit():
        results_vec.append(int(b))

results_vec = list(sorted(set(results_vec)))
print(results_vec)


battery_data = []
for v in m.getVars():
    if v.X > 0.5 and 'y' in v.VarName:
        battery_data.append(v.VarName)

mellomhold_bat = []
for a in battery_data:
    b = re.findall(r'\d+',a)
    mellomhold_bat.extend(b)

results_vec_y = []
for b in mellomhold_bat:
    if b.isdigit():
        results_vec_y.append(int(b))

battery_station = results_vec_y[0::2]
batter_choice = results_vec_y[1::2]

for i in range(len(battery_station)):
    print('Port %s will supply vessel with %s batteries' %(battery_station[i],batter_choice[i]) )
        #battery_data.append(int(v.VarName[4]))

print('The nodes in the solution:',results_vec)





pos = nx.kamada_kawai_layout(G)


options = {'node_color': 'cyan','node_size': 200,'width': 0.5}


plt.figure()
nx.draw(G,pos, with_labels=True, **options)

plt.figure()
nx.draw(G,pos, with_labels=True, **options)
shortPath = [(results_vec[i],results_vec[i-1]) for i in range(len(results_vec)-1,0,-1)]
nx.draw_networkx_edges(G,pos,edgelist=shortPath,width=5,edge_color='red')



plt.show()

